# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
from waptpackage import PackageEntry


def update_package():
    # Declaring local variables
    package_updated = False

    # Interact differently with Luti
    if params.get("running_as_luti"):
        return "OK"
    

    # Set up my "my_bitwarden_server" in the package
    my_bitwarden_server = ""
    with open("setup.py", "r", encoding="utf8") as f:
        for line in f.readlines():
            if line.startswith("my_bitwarden_server"):
                my_bitwarden_server = line.split("=")[1].split('"')[1]
                break 
    old_my_bitwarden_server = my_bitwarden_server

    ask_input(
        control.package,
        "Please enter the URL address of the Bitwarden server associated with your configuration",
        my_bitwarden_server,
        raise_error=True,
    )

    # Updating setup.py my_bitwarden_server variable
    new_lines = []
    with open("setup.py", "r", encoding="utf8") as f:
        for line in f.readlines():
            if line.startswith("tis-bitwarden-config-template"):
                line = 'tis-bitwarden-config-template = "%s"\n' % tis - bitwarden - config - template
            new_lines.append(line)
    with open("setup.py", "w", encoding="utf8", newline="\n") as f:
        f.writelines(new_lines)

    # Renaming package
    if "template" in control.package:
        complete_control_package(control)
        complete_control_name(control)
        if "template" in control.package:
            error("Please rename the package.")
        else:
            version = str(int(control.get_software_version()) + 1)
        ask_message(
            control.package,
            "Please note that you will still need to edit this package to apply your own configuration that is compliant with your company's internal policies. You are sole responsible for the use of this package on your network.",
            48,
        )
    else:
        version = str(int(control.get_software_version()))

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated
